Index: palm/trunk/SOURCE/chemistry_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 3597)
+++ palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 3600)
@@ -1367,128 +1390,130 @@
 !------------------------------------------------------------------------------!
     
-    SUBROUTINE chem_data_output_mask( av, variable, found, local_pf )
-    
-       USE control_parameters
-       USE indices
-       USE kinds
-       USE pegrid,             ONLY: myid, threads_per_task
-       USE surface_mod,        ONLY: get_topography_top_index_ji
-
-       IMPLICIT NONE
-
-       CHARACTER(LEN=5) ::  grid        !< flag to distinquish between staggered grids
-
-       CHARACTER (LEN=*)::  variable    !< 
-       INTEGER(iwp)     ::  av          !< flag to control data output of instantaneous or time-averaged data
-       LOGICAL          ::  found       !< 
-       REAL(wp), DIMENSION(mask_size_l(mid,1),mask_size_l(mid,2),mask_size_l(mid,3)) ::  &
-                 local_pf   !< 
-
-
-       !-- local variables.
-       CHARACTER(len=16)    ::  spec_name
-       INTEGER(iwp) ::  lsp
-       INTEGER(iwp) ::  i               !< grid index along x-direction
-       INTEGER(iwp) ::  j               !< grid index along y-direction
-       INTEGER(iwp) ::  k               !< grid index along z-direction
-       INTEGER(iwp) ::  topo_top_ind    !< k index of highest horizontal surface
-
-       found = .TRUE.
-       grid  = 's'
-
-       spec_name = TRIM( variable(4:) )
-
-       DO lsp=1,nspec
-          IF (TRIM(spec_name) == TRIM(chem_species(lsp)%name) )               THEN             
-!
-!--   todo: remove or replace by "CALL message" mechanism (kanani)
-!                 IF(myid == 0 .AND. chem_debug0 )  WRITE(6,*) 'Output of species ' // TRIM(variable)  // &
-!                                                           TRIM(chem_species(lsp)%name)       
-             IF (av == 0) THEN
-                IF ( .NOT. mask_surface(mid) )  THEN
-
-                   DO  i = 1, mask_size_l(mid,1)
-                      DO  j = 1, mask_size_l(mid,2) 
-                         DO  k = 1, mask_size(mid,3) 
-                             local_pf(i,j,k) = chem_species(lsp)%conc(  &
-                                                  mask_k(mid,k),        &
-                                                  mask_j(mid,j),        &
-                                                  mask_i(mid,i)      )
-                         ENDDO
+ SUBROUTINE chem_data_output_mask( av, variable, found, local_pf )
+
+    USE control_parameters
+    USE indices
+    USE kinds
+    USE pegrid,                                                                       &
+        ONLY:  myid, threads_per_task
+    USE surface_mod,                                                                  &
+        ONLY:  get_topography_top_index_ji
+
+    IMPLICIT NONE
+
+    CHARACTER(LEN=5) ::  grid        !< flag to distinquish between staggered grids
+
+    CHARACTER (LEN=*)::  variable    !< 
+    INTEGER(iwp)     ::  av          !< flag to control data output of instantaneous or time-averaged data
+    LOGICAL          ::  found       !< 
+    REAL(wp), DIMENSION(mask_size_l(mid,1),mask_size_l(mid,2),mask_size_l(mid,3)) ::  &
+              local_pf   !< 
+
+
+    !-- local variables.
+    CHARACTER(len=16)    ::  spec_name
+    INTEGER(iwp) ::  lsp
+    INTEGER(iwp) ::  i               !< grid index along x-direction
+    INTEGER(iwp) ::  j               !< grid index along y-direction
+    INTEGER(iwp) ::  k               !< grid index along z-direction
+    INTEGER(iwp) ::  topo_top_ind    !< k index of highest horizontal surface
+
+    found = .TRUE.
+    grid  = 's'
+
+    spec_name = TRIM( variable(4:) )
+
+    DO lsp=1,nspec
+       IF (TRIM(spec_name) == TRIM(chem_species(lsp)%name) )               THEN             
+!
+!-- todo: remove or replace by "CALL message" mechanism (kanani)
+!              IF(myid == 0 .AND. chem_debug0 )  WRITE(6,*) 'Output of species ' // TRIM(variable)  // &
+!                                                        TRIM(chem_species(lsp)%name)       
+          IF (av == 0) THEN
+             IF ( .NOT. mask_surface(mid) )  THEN
+
+                DO  i = 1, mask_size_l(mid,1)
+                   DO  j = 1, mask_size_l(mid,2) 
+                      DO  k = 1, mask_size(mid,3) 
+                          local_pf(i,j,k) = chem_species(lsp)%conc(  &
+                                               mask_k(mid,k),        &
+                                               mask_j(mid,j),        &
+                                               mask_i(mid,i)      )
                       ENDDO
                    ENDDO
-
-                ELSE
+                ENDDO
+
+             ELSE
 !              
-!--                Terrain-following masked output
-                   DO  i = 1, mask_size_l(mid,1)
-                      DO  j = 1, mask_size_l(mid,2)
+!--             Terrain-following masked output
+                DO  i = 1, mask_size_l(mid,1)
+                   DO  j = 1, mask_size_l(mid,2)
 !              
-!--                      Get k index of highest horizontal surface
-                         topo_top_ind = get_topography_top_index_ji( &
-                                           mask_j(mid,j),  &
-                                           mask_i(mid,i),  &
-                                           grid                    )
+!--                   Get k index of highest horizontal surface
+                      topo_top_ind = get_topography_top_index_ji( &
+                                        mask_j(mid,j),  &
+                                        mask_i(mid,i),  &
+                                        grid                    )
 !              
-!--                      Save output array
-                         DO  k = 1, mask_size_l(mid,3)
-                            local_pf(i,j,k) = chem_species(lsp)%conc( &
-                                                 MIN( topo_top_ind+mask_k(mid,k), &
-                                                      nzt+1 ),        &
-                                                 mask_j(mid,j),       &
-                                                 mask_i(mid,i)      )
-                         ENDDO
+!--                   Save output array
+                      DO  k = 1, mask_size_l(mid,3)
+                         local_pf(i,j,k) = chem_species(lsp)%conc( &
+                                              MIN( topo_top_ind+mask_k(mid,k), &
+                                                   nzt+1 ),        &
+                                              mask_j(mid,j),       &
+                                              mask_i(mid,i)      )
                       ENDDO
                    ENDDO
-
-                ENDIF
-             ELSE
-                IF ( .NOT. mask_surface(mid) )  THEN
-
-                   DO  i = 1, mask_size_l(mid,1)
-                      DO  j = 1, mask_size_l(mid,2)
-                         DO  k =  1, mask_size_l(mid,3)
-                             local_pf(i,j,k) = chem_species(lsp)%conc_av(  &
-                                                  mask_k(mid,k),           &
-                                                  mask_j(mid,j),           &
-                                                  mask_i(mid,i)         )
-                         ENDDO
+                ENDDO
+
+             ENDIF
+          ELSE
+             IF ( .NOT. mask_surface(mid) )  THEN
+
+                DO  i = 1, mask_size_l(mid,1)
+                   DO  j = 1, mask_size_l(mid,2)
+                      DO  k =  1, mask_size_l(mid,3)
+                          local_pf(i,j,k) = chem_species(lsp)%conc_av(  &
+                                               mask_k(mid,k),           &
+                                               mask_j(mid,j),           &
+                                               mask_i(mid,i)         )
                       ENDDO
                    ENDDO
-
-                ELSE
+                ENDDO
+
+             ELSE
 !              
-!--                Terrain-following masked output
-                   DO  i = 1, mask_size_l(mid,1)
-                      DO  j = 1, mask_size_l(mid,2)
+!--             Terrain-following masked output
+                DO  i = 1, mask_size_l(mid,1)
+                   DO  j = 1, mask_size_l(mid,2)
 !              
-!--                      Get k index of highest horizontal surface
-                         topo_top_ind = get_topography_top_index_ji( &
-                                           mask_j(mid,j),  &
-                                           mask_i(mid,i),  &
-                                           grid                    )
+!--                   Get k index of highest horizontal surface
+                      topo_top_ind = get_topography_top_index_ji( &
+                                        mask_j(mid,j),  &
+                                        mask_i(mid,i),  &
+                                        grid                    )
 !              
-!--                      Save output array
-                         DO  k = 1, mask_size_l(mid,3)
-                            local_pf(i,j,k) = chem_species(lsp)%conc_av(  &
-                                                 MIN( topo_top_ind+mask_k(mid,k), &
-                                                      nzt+1 ),            &
-                                                 mask_j(mid,j),           &
-                                                 mask_i(mid,i)         )
-                         ENDDO
+!--                   Save output array
+                      DO  k = 1, mask_size_l(mid,3)
+                         local_pf(i,j,k) = chem_species(lsp)%conc_av(  &
+                                              MIN( topo_top_ind+mask_k(mid,k), &
+                                                   nzt+1 ),            &
+                                              mask_j(mid,j),           &
+                                              mask_i(mid,i)         )
                       ENDDO
                    ENDDO
-
-                ENDIF
-
+                ENDDO
 
              ENDIF
-             found = .FALSE.
+
+
           ENDIF
-       ENDDO
-
-       RETURN
-     
-    END SUBROUTINE chem_data_output_mask      
+          found = .FALSE.
+       ENDIF
+    ENDDO
+
+    RETURN
+
+ END SUBROUTINE chem_data_output_mask      
 
 !
@@ -1500,29 +1525,29 @@
 !> It is called out from subroutine netcdf.
 !------------------------------------------------------------------------------!
-    SUBROUTINE chem_define_netcdf_grid( var, found, grid_x, grid_y, grid_z )
-
-       IMPLICIT NONE
-
-       CHARACTER (LEN=*), INTENT(IN)  ::  var          !<
-       LOGICAL, INTENT(OUT)           ::  found        !<
-       CHARACTER (LEN=*), INTENT(OUT) ::  grid_x       !<
-       CHARACTER (LEN=*), INTENT(OUT) ::  grid_y       !<
-       CHARACTER (LEN=*), INTENT(OUT) ::  grid_z       !<
-
-       found  = .TRUE.
-
-       IF ( var(1:3) == 'kc_' .OR. var(1:3) == 'em_' )   THEN                   !< always the same grid for chemistry variables
-          grid_x = 'x'
-          grid_y = 'y'
-          grid_z = 'zu'                             
-       ELSE
-          found  = .FALSE.
-          grid_x = 'none'
-          grid_y = 'none'
-          grid_z = 'none'
-       ENDIF
-
-
-    END SUBROUTINE chem_define_netcdf_grid
+ SUBROUTINE chem_define_netcdf_grid( var, found, grid_x, grid_y, grid_z )
+
+    IMPLICIT NONE
+
+    CHARACTER (LEN=*), INTENT(IN)  ::  var          !<
+    LOGICAL, INTENT(OUT)           ::  found        !<
+    CHARACTER (LEN=*), INTENT(OUT) ::  grid_x       !<
+    CHARACTER (LEN=*), INTENT(OUT) ::  grid_y       !<
+    CHARACTER (LEN=*), INTENT(OUT) ::  grid_z       !<
+
+    found  = .TRUE.
+
+    IF ( var(1:3) == 'kc_' .OR. var(1:3) == 'em_' )   THEN                   !< always the same grid for chemistry variables
+       grid_x = 'x'
+       grid_y = 'y'
+       grid_z = 'zu'                             
+    ELSE
+       found  = .FALSE.
+       grid_x = 'none'
+       grid_y = 'none'
+       grid_z = 'none'
+    ENDIF
+
+
+ END SUBROUTINE chem_define_netcdf_grid
 !
 !------------------------------------------------------------------------------!
@@ -1532,87 +1557,88 @@
 !> Subroutine defining header output for chemistry model
 !------------------------------------------------------------------------------!
-    SUBROUTINE chem_header ( io )
-       
-       IMPLICIT NONE 
- 
-       INTEGER(iwp), INTENT(IN) ::  io            !< Unit of the output file
-       INTEGER(iwp)             :: lsp            !< running index for chem spcs
-       INTEGER(iwp)             :: cs_fixed 
-       CHARACTER (LEN=80)       :: docsflux_chr
-       CHARACTER (LEN=80)       :: docsinit_chr
-
-!
-!--    Write chemistry model  header
-       WRITE( io, 1 )
-
-!--    Gasphase reaction status
-       IF ( chem_gasphase_on )  THEN 
-          WRITE( io, 2 )
-       ELSE
-          WRITE( io, 3 )
+ SUBROUTINE chem_header( io )
+
+    IMPLICIT NONE 
+
+    INTEGER(iwp), INTENT(IN) ::  io            !< Unit of the output file
+    INTEGER(iwp)             :: lsp            !< running index for chem spcs
+    INTEGER(iwp)             :: cs_fixed 
+    CHARACTER (LEN=80)       :: docsflux_chr
+    CHARACTER (LEN=80)       :: docsinit_chr
+
+!
+!-- Write chemistry model  header
+    WRITE( io, 1 )
+
+!-- Gasphase reaction status
+    IF ( chem_gasphase_on )  THEN 
+       WRITE( io, 2 )
+    ELSE
+       WRITE( io, 3 )
+    ENDIF
+
+!
+!-- Chemistry time-step
+    WRITE ( io, 4 ) cs_time_step
+
+!-- Emission mode info
+    IF ( mode_emis == "DEFAULT" )  THEN 
+       WRITE( io, 5 ) 
+    ELSEIF ( mode_emis == "PARAMETERIZED" )  THEN 
+       WRITE( io, 6 )
+    ELSEIF ( mode_emis == "PRE-PROCESSED" )  THEN 
+       WRITE( io, 7 )
+    ENDIF 
+
+!-- Photolysis scheme info
+    IF ( photolysis_scheme == "simple" )      THEN
+       WRITE( io, 8 ) 
+    ELSEIF (photolysis_scheme == "constant" ) THEN
+       WRITE( io, 9 )
+    ENDIF
+
+!-- Emission flux info
+    lsp = 1
+    docsflux_chr ='Chemical species for surface emission flux: ' 
+    DO WHILE ( surface_csflux_name(lsp) /= 'novalue' )
+       docsflux_chr = TRIM( docsflux_chr ) // ' ' // TRIM( surface_csflux_name(lsp) ) // ','  
+       IF ( LEN_TRIM( docsflux_chr ) >= 75 )  THEN
+        WRITE ( io, 10 )  docsflux_chr
+        docsflux_chr = '       '
        ENDIF
-
-!      Chemistry time-step
-       WRITE ( io, 4 ) cs_time_step
-
-!--    Emission mode info
-       IF ( mode_emis == "DEFAULT" )  THEN 
-          WRITE( io, 5 ) 
-       ELSEIF ( mode_emis == "PARAMETERIZED" )  THEN 
-          WRITE( io, 6 )
-       ELSEIF ( mode_emis == "PRE-PROCESSED" )  THEN 
-          WRITE( io, 7 )
-       ENDIF 
-
-!--    Photolysis scheme info
-       IF ( photolysis_scheme == "simple" )      THEN
-          WRITE( io, 8 ) 
-       ELSEIF (photolysis_scheme == "conastant" ) THEN
-          WRITE( io, 9 )
+       lsp = lsp + 1
+    ENDDO
+
+    IF ( docsflux_chr /= '' )  THEN
+       WRITE ( io, 10 )  docsflux_chr
+    ENDIF
+
+
+!-- initializatoin of Surface and profile chemical species
+
+    lsp = 1
+    docsinit_chr ='Chemical species for initial surface and profile emissions: ' 
+    DO WHILE ( cs_name(lsp) /= 'novalue' )
+       docsinit_chr = TRIM( docsinit_chr ) // ' ' // TRIM( cs_name(lsp) ) // ','  
+       IF ( LEN_TRIM( docsinit_chr ) >= 75 )  THEN
+        WRITE ( io, 11 )  docsinit_chr
+        docsinit_chr = '       '
        ENDIF
- 
- !--   Emission flux info
-       lsp = 1
-       docsflux_chr ='Chemical species for surface emission flux: ' 
-       DO WHILE ( surface_csflux_name(lsp) /= 'novalue' )
-          docsflux_chr = TRIM( docsflux_chr ) // ' ' // TRIM( surface_csflux_name(lsp) ) // ','  
-          IF ( LEN_TRIM( docsflux_chr ) >= 75 )  THEN
-           WRITE ( io, 10 )  docsflux_chr
-           docsflux_chr = '       '
-          ENDIF
-          lsp = lsp + 1
-       ENDDO
- 
-       IF ( docsflux_chr /= '' )  THEN
-          WRITE ( io, 10 )  docsflux_chr
-       ENDIF
-
-
-!--    initializatoin of Surface and profile chemical species
-
-       lsp = 1
-       docsinit_chr ='Chemical species for initial surface and profile emissions: ' 
-       DO WHILE ( cs_name(lsp) /= 'novalue' )
-          docsinit_chr = TRIM( docsinit_chr ) // ' ' // TRIM( cs_name(lsp) ) // ','  
-          IF ( LEN_TRIM( docsinit_chr ) >= 75 )  THEN
-           WRITE ( io, 11 )  docsinit_chr
-           docsinit_chr = '       '
-          ENDIF
-          lsp = lsp + 1
-       ENDDO
- 
-       IF ( docsinit_chr /= '' )  THEN
-          WRITE ( io, 11 )  docsinit_chr
-       ENDIF
-
-!--    number of variable and fix chemical species and number of reactions
-       cs_fixed = nspec - nvar
-       WRITE ( io, * ) '   --> Chemical species, variable: ', nvar
-       WRITE ( io, * ) '   --> Chemical species, fixed   : ', cs_fixed
-       WRITE ( io, * ) '   --> Total number of reactions : ', nreact
+       lsp = lsp + 1
+    ENDDO
+
+    IF ( docsinit_chr /= '' )  THEN
+       WRITE ( io, 11 )  docsinit_chr
+    ENDIF
+
+!-- number of variable and fix chemical species and number of reactions
+    cs_fixed = nspec - nvar
+    WRITE ( io, * ) '   --> Chemical species, variable: ', nvar
+    WRITE ( io, * ) '   --> Chemical species, fixed   : ', cs_fixed
+    WRITE ( io, * ) '   --> Total number of reactions : ', nreact
 
 
 1   FORMAT (//' Chemistry model information:'/                                  &
-              ' ----------------------------'/)
+           ' ----------------------------'/)
 2   FORMAT ('    --> Chemical reactions are turned on')
 3   FORMAT ('    --> Chemical reactions are turned off')
@@ -1627,5 +1653,5 @@
 !
 !
-    END SUBROUTINE chem_header
+ END SUBROUTINE chem_header
 
 !
@@ -1636,17 +1662,18 @@
 !> Subroutine initializating chemistry_model_mod
 !------------------------------------------------------------------------------!
-    SUBROUTINE chem_init
-
-       USE control_parameters,                                                  &
-          ONLY: message_string, io_blocks, io_group, turbulent_inflow
-       USE arrays_3d,                                                           &
-           ONLY: mean_inflow_profiles
-       USE pegrid
-
-       IMPLICIT   none
-   !-- local variables
-       INTEGER                 :: i,j               !< running index for for horiz numerical grid points
-       INTEGER                 :: lsp               !< running index for chem spcs
-       INTEGER                 :: lpr_lev           !< running index for chem spcs profile level
+ SUBROUTINE chem_init
+
+    USE control_parameters,                                                  &
+        ONLY:  message_string, io_blocks, io_group, turbulent_inflow
+    USE arrays_3d,                                                           &
+        ONLY:  mean_inflow_profiles
+    USE pegrid
+
+    IMPLICIT NONE
+!-- local variables
+    INTEGER(iwp) ::  i                 !< running index for for horiz numerical grid points
+    INTEGER(iwp) ::  j                 !< running index for for horiz numerical grid points
+    INTEGER(iwp) ::  lsp               !< running index for chem spcs
+    INTEGER(iwp) ::  lpr_lev           !< running index for chem spcs profile level
 !
 !-- NOPOINTER version not implemented yet
@@ -1657,41 +1684,41 @@
 !
 !-- Allocate memory for chemical species
-       ALLOCATE( chem_species(nspec) )
-       ALLOCATE( spec_conc_1 (nzb:nzt+1,nysg:nyng,nxlg:nxrg,nspec) )
-       ALLOCATE( spec_conc_2 (nzb:nzt+1,nysg:nyng,nxlg:nxrg,nspec) )
-       ALLOCATE( spec_conc_3 (nzb:nzt+1,nysg:nyng,nxlg:nxrg,nspec) )
-       ALLOCATE( spec_conc_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg,nspec) ) 
-       ALLOCATE( phot_frequen(nphot) ) 
-       ALLOCATE( freq_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg,nphot) )
-       ALLOCATE( bc_cs_t_val(nspec) )
+    ALLOCATE( chem_species(nspec) )
+    ALLOCATE( spec_conc_1 (nzb:nzt+1,nysg:nyng,nxlg:nxrg,nspec) )
+    ALLOCATE( spec_conc_2 (nzb:nzt+1,nysg:nyng,nxlg:nxrg,nspec) )
+    ALLOCATE( spec_conc_3 (nzb:nzt+1,nysg:nyng,nxlg:nxrg,nspec) )
+    ALLOCATE( spec_conc_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg,nspec) ) 
+    ALLOCATE( phot_frequen(nphot) ) 
+    ALLOCATE( freq_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg,nphot) )
+    ALLOCATE( bc_cs_t_val(nspec) )
 !
 !-- Initialize arrays
-       spec_conc_1 (:,:,:,:) = 0.0_wp
-       spec_conc_2 (:,:,:,:) = 0.0_wp
-       spec_conc_3 (:,:,:,:) = 0.0_wp
-       spec_conc_av(:,:,:,:) = 0.0_wp
-
-
-       DO lsp = 1, nspec
-          chem_species(lsp)%name    = spc_names(lsp)
-
-          chem_species(lsp)%conc   (nzb:nzt+1,nysg:nyng,nxlg:nxrg)       => spec_conc_1 (:,:,:,lsp)
-          chem_species(lsp)%conc_p (nzb:nzt+1,nysg:nyng,nxlg:nxrg)       => spec_conc_2 (:,:,:,lsp)
-          chem_species(lsp)%tconc_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg)       => spec_conc_3 (:,:,:,lsp)
-          chem_species(lsp)%conc_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg)       => spec_conc_av(:,:,:,lsp)     
-
-          ALLOCATE (chem_species(lsp)%cssws_av(nysg:nyng,nxlg:nxrg))                   
-          chem_species(lsp)%cssws_av    = 0.0_wp
-!
-!--       The following block can be useful when emission module is not applied. &
-!--       if emission module is applied the following block will be overwritten.
-          ALLOCATE (chem_species(lsp)%flux_s_cs(nzb+1:nzt,0:threads_per_task-1))   
-          ALLOCATE (chem_species(lsp)%diss_s_cs(nzb+1:nzt,0:threads_per_task-1))   
-          ALLOCATE (chem_species(lsp)%flux_l_cs(nzb+1:nzt,nys:nyn,0:threads_per_task-1)) 
-          ALLOCATE (chem_species(lsp)%diss_l_cs(nzb+1:nzt,nys:nyn,0:threads_per_task-1))   
-          chem_species(lsp)%flux_s_cs = 0.0_wp                                     
-          chem_species(lsp)%flux_l_cs = 0.0_wp                                     
-          chem_species(lsp)%diss_s_cs = 0.0_wp                                      
-          chem_species(lsp)%diss_l_cs = 0.0_wp                                     
+    spec_conc_1 (:,:,:,:) = 0.0_wp
+    spec_conc_2 (:,:,:,:) = 0.0_wp
+    spec_conc_3 (:,:,:,:) = 0.0_wp
+    spec_conc_av(:,:,:,:) = 0.0_wp
+
+
+    DO lsp = 1, nspec
+       chem_species(lsp)%name    = spc_names(lsp)
+
+       chem_species(lsp)%conc   (nzb:nzt+1,nysg:nyng,nxlg:nxrg)       => spec_conc_1 (:,:,:,lsp)
+       chem_species(lsp)%conc_p (nzb:nzt+1,nysg:nyng,nxlg:nxrg)       => spec_conc_2 (:,:,:,lsp)
+       chem_species(lsp)%tconc_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg)       => spec_conc_3 (:,:,:,lsp)
+       chem_species(lsp)%conc_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg)       => spec_conc_av(:,:,:,lsp)     
+
+       ALLOCATE (chem_species(lsp)%cssws_av(nysg:nyng,nxlg:nxrg))                   
+       chem_species(lsp)%cssws_av    = 0.0_wp
+!
+!--    The following block can be useful when emission module is not applied. &
+!--    if emission module is applied the following block will be overwritten.
+       ALLOCATE (chem_species(lsp)%flux_s_cs(nzb+1:nzt,0:threads_per_task-1))   
+       ALLOCATE (chem_species(lsp)%diss_s_cs(nzb+1:nzt,0:threads_per_task-1))   
+       ALLOCATE (chem_species(lsp)%flux_l_cs(nzb+1:nzt,nys:nyn,0:threads_per_task-1)) 
+       ALLOCATE (chem_species(lsp)%diss_l_cs(nzb+1:nzt,nys:nyn,0:threads_per_task-1))   
+       chem_species(lsp)%flux_s_cs = 0.0_wp                                     
+       chem_species(lsp)%flux_l_cs = 0.0_wp                                     
+       chem_species(lsp)%diss_s_cs = 0.0_wp                                      
+       chem_species(lsp)%diss_l_cs = 0.0_wp                                     
 !
 !--   Allocate memory for initial concentration profiles
@@ -1701,84 +1728,84 @@
 !--               We have to find another solution since chem_init should
 !--               eventually be called from init_3d_model!!)
-          ALLOCATE ( chem_species(lsp)%conc_pr_init(0:nz+1) )
-          chem_species(lsp)%conc_pr_init(:) = 0.0_wp
-
-       ENDDO
-
-!
-!--    Initial concentration of profiles is prescribed by parameters cs_profile
-!--    and cs_heights in the namelist &chemistry_parameters
-       CALL chem_init_profiles      
-            
-            
+       ALLOCATE ( chem_species(lsp)%conc_pr_init(0:nz+1) )
+       chem_species(lsp)%conc_pr_init(:) = 0.0_wp
+
+    ENDDO
+
+!
+!-- Initial concentration of profiles is prescribed by parameters cs_profile
+!-- and cs_heights in the namelist &chemistry_parameters
+    CALL chem_init_profiles      
+
+
 !
 !-- Initialize model variables
 
 
-       IF ( TRIM( initializing_actions ) /= 'read_restart_data'  .AND.            &
-            TRIM( initializing_actions ) /= 'cyclic_fill' )  THEN
+    IF ( TRIM( initializing_actions ) /= 'read_restart_data'  .AND.            &
+         TRIM( initializing_actions ) /= 'cyclic_fill' )  THEN
 
 
 !--    First model run of a possible job queue.
 !--    Initial profiles of the variables must be computed.
-          IF ( INDEX( initializing_actions, 'set_1d-model_profiles' ) /= 0 )  THEN
-            CALL location_message( 'initializing with 1D chemistry model profiles', .FALSE. )
-!
-!--        Transfer initial profiles to the arrays of the 3D model
-             DO lsp = 1, nspec
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO lpr_lev = 1, nz + 1
-                         chem_species(lsp)%conc(lpr_lev,j,i) = chem_species(lsp)%conc_pr_init(lpr_lev)
-                      ENDDO
-                   ENDDO
-                ENDDO   
-             ENDDO
-          
-          ELSEIF ( INDEX(initializing_actions, 'set_constant_profiles') /= 0 )    &
-          THEN
-             CALL location_message( 'initializing with constant chemistry profiles', .FALSE. )
-
-             DO lsp = 1, nspec 
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      chem_species(lsp)%conc(:,j,i) = chem_species(lsp)%conc_pr_init    
+       IF ( INDEX( initializing_actions, 'set_1d-model_profiles' ) /= 0 )  THEN
+         CALL location_message( 'initializing with 1D chemistry model profiles', .FALSE. )
+!
+!--       Transfer initial profiles to the arrays of the 3D model
+          DO lsp = 1, nspec
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   DO lpr_lev = 1, nz + 1
+                      chem_species(lsp)%conc(lpr_lev,j,i) = chem_species(lsp)%conc_pr_init(lpr_lev)
                    ENDDO
                 ENDDO
+             ENDDO   
+          ENDDO
+
+       ELSEIF ( INDEX(initializing_actions, 'set_constant_profiles') /= 0 )    &
+       THEN
+          CALL location_message( 'initializing with constant chemistry profiles', .FALSE. )
+
+          DO lsp = 1, nspec 
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   chem_species(lsp)%conc(:,j,i) = chem_species(lsp)%conc_pr_init    
+                ENDDO
              ENDDO
-
-          ENDIF
-
-!
-!--       If required, change the surface chem spcs at the start of the 3D run
-          IF ( cs_surface_initial_change(1) /= 0.0_wp ) THEN            
-             DO lsp = 1, nspec 
-                chem_species(lsp)%conc(nzb,:,:) = chem_species(lsp)%conc(nzb,:,:) +  &
-                                                  cs_surface_initial_change(lsp)
-             ENDDO
-          ENDIF 
-!
-!--      Initiale old and new time levels. 
-          DO lsp = 1, nvar
-             chem_species(lsp)%tconc_m = 0.0_wp                      
-             chem_species(lsp)%conc_p  = chem_species(lsp)%conc     
           ENDDO
 
        ENDIF
 
-
-
-!---   new code add above this line
-       DO lsp = 1, nphot
-          phot_frequen(lsp)%name = phot_names(lsp)
-!
-!--   todo: remove or replace by "CALL message" mechanism (kanani)
+!
+!--    If required, change the surface chem spcs at the start of the 3D run
+       IF ( cs_surface_initial_change(1) /= 0.0_wp ) THEN            
+          DO lsp = 1, nspec 
+             chem_species(lsp)%conc(nzb,:,:) = chem_species(lsp)%conc(nzb,:,:) +  &
+                                               cs_surface_initial_change(lsp)
+          ENDDO
+       ENDIF 
+!
+!--    Initiale old and new time levels. 
+       DO lsp = 1, nvar
+          chem_species(lsp)%tconc_m = 0.0_wp                      
+          chem_species(lsp)%conc_p  = chem_species(lsp)%conc     
+       ENDDO
+
+    ENDIF
+
+
+
+!--- new code add above this line
+    DO lsp = 1, nphot
+       phot_frequen(lsp)%name = phot_names(lsp)
+!
+!-- todo: remove or replace by "CALL message" mechanism (kanani)
 !         IF( myid == 0 )  THEN
-!            WRITE(6,'(a,i4,3x,a)')  'Photolysis: ',lsp,trim(phot_names(lsp))
+!            WRITE(6,'(a,i4,3x,a)')  'Photolysis: ',lsp,TRIM(phot_names(lsp))
 !         ENDIF 
-             phot_frequen(lsp)%freq(nzb:nzt+1,nysg:nyng,nxlg:nxrg)    => freq_1(:,:,:,lsp)
-       ENDDO
-
-       RETURN
+          phot_frequen(lsp)%freq(nzb:nzt+1,nysg:nyng,nxlg:nxrg)    => freq_1(:,:,:,lsp)
+    ENDDO
+
+    RETURN
 
  END SUBROUTINE chem_init
